/*	
 *	usbsys.h
 *
 *	USB VXevO
 *	Copyright (c) 1997 Philips Semiconductors
 *	Copyright (c) 2002 Naoyuki Sawa
 *
 *	* Mon Aug 16 12:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 *	* Mon Sep 12 22:31:00 JST 2002 Naoyuki Sawa
 *	- USB Mass Storage Class BULK-Only ̒`ǉ܂B
 *	- MS-DOS FAT File System ̒`ǉ܂B
 */
#ifndef __USBSYS_H__
#define __USBSYS_H__

/****************************************************************************
 *	萔E^
 ****************************************************************************/

/* foCXNGXg\
 * * ڍׂUSBdlQƂĂB
 */
typedef struct _DEVICE_REQUEST {
	unsigned char bmRequestType;
	unsigned char bRequest;
	unsigned short wValue;
	unsigned short wIndex;
	unsigned short wLength;
} DEVICE_REQUEST;

/* USBtbN
 * * usb_hook()ւ̈Ƃėp܂B
 *   mode͕Kݒ肵ĂBiʏ 0x00:NONISO Ȃ̂ŁA[NAłłj
 *   Cxg/NGXgnh͎ĝݒ肵AgȂ̂NULLɂĂB
 */
typedef struct _USBINFO {
	/* USBC mode */
	int mode;			/* USBC[h(D12_ENDP_NONISO/ISOOUT/ISOIN/ISOIO) */
	/* USBC raw event */
	void (*bus_reset)();		/* oXZbgCxg */
	void (*ep1_rxdone)(int st);	/* EP1MCxg  */
	void (*ep1_txdone)(int st);	/* EP1MCxg  */
	void (*ep2_rxdone)(int st);	/* EP2MCxg  */
	void (*ep2_txdone)(int st);	/* EP2MCxg  */
	/* Device request */
	void (*standard_request)(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
	void (*class_request)(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
	void (*vendor_request)(const DEVICE_REQUEST* req, const unsigned char* dat, int len);
} USBINFO;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

/* USBRg[̐tbN܂B
 * [in]
 *	ui	USBtbNւ̃|C^
 *		usb_hook()̓|C^̎weRs[ĕێ܂B
 *		֐ԂAJĂ܂Ă\܂B
 * [note]
 *	* ɃtbNĂꍇ́AIɂtbNĂtbN܂B
 *	  ]āAusb_hook()֐͏ɐ܂B
 */
void usb_hook(const USBINFO* ui);

/* USBRg[̐tbN܂B
 * [note]
 *	* ܂tbNĂȂꍇ́Å֐͉܂B
 */
void usb_unhook();

/* Gh|Cg0 IN/OUT Xg[܂B
 */
void usb_ep0_stall();

/* Gh|Cg0 IN(foCXzXg) gāAf[^𑗐M܂B
 * [in]
 *	ptr	Mf[^̐擪AhX
 *	len	Mf[^̃oCg
 * [out]
 *	* ̊֐́AfoCXNGXgւ̉ƂĂ̂ݗpł܂B
 *	  USBINFO\̂Ɏw肵foCXNGXgnhR[obNꂽɁA
 *	  R[obN̒炾p\łB̓IȗpŕÂƂłB
 *	  - GETNGXgɑ΂Rg[f[^ԐM
 *	  - SETNGXgɑ΂Xe[^X(pPbg)ԐM
 *	  ȊO̖ړIE^C~OŗpƁA\łȂʂƂȂ܂B
 *	* M͔񓯊ɍs܂B
 *	  M܂ŁAptr̎wf[^QƂꑱ܂B
 *	  f[^J/ύXȂ悤CĂB
 *	  ̃foCXNGXgMAf[^J/ύXĂSłB
 */
void usb_ep0_tx(const char* ptr, int len);

/****************************************************************************
 *	eUSBNX֘Adl̒萔E^Ȃǁiǉj
 ****************************************************************************/

/*-------------------- USB Mass Storage Class BULK-Only --------------------*/

/* Command Block Wrapper
 * Mass Storage Class Bulk-Only Transport dlQƂĂB
 */
typedef struct _CBW {
	unsigned int dCBWSignature;		/*  0- 3 */
	unsigned int dCBWTag;			/*  4- 7 */
	unsigned int dCBWDataTransferLength;	/*  8-11 */
	unsigned char bmCBWFlags;		/*    12 */
	unsigned char bCBWLUN		:4;	/*    13 */
	unsigned char			:4;
	unsigned char bCBWCBLength	:5;	/*    14 */
	unsigned char			:3;
	unsigned char CBWCB[16];		/* 15-30 */
} CBW;
#define CBW_SIZE	31 /* sizeof(CBW)ł̓pfBÔŃ_! */
#define CBW_SIGNATURE	0x43425355 /* 'USBC' */

/* Command Status Wrapper
 * Mass Storage Class Bulk-Only Transport dlQƂĂB
 */
typedef struct _CSW {
	unsigned int dCSWSignature;		/*  0- 3 */
	unsigned int dCSWTag;			/*  4- 7 */
	unsigned int dCSWDataResidue;		/*  8-11 */
	unsigned char bCSWStatus;		/*    12 */
} CSW;
#define CSW_SIZE	13 /* sizeof(CSW)ł̓pfBÔŃ_! */
#define CSW_SIGNATURE	0x53425355 /* 'USBS' */

/*-------------------- MS-DOS FAT File System --------------------*/

typedef struct _FAT_BOOT_SECTOR {
	unsigned char ignored[3];	/*  0- 2 */
	unsigned char system_id[8];	/*  3-10 */
	unsigned char sector_size[2];	/* 11-12 */
	unsigned char cluster_size;	/*    13 */
	unsigned short reserved;	/* 14-15 */
	unsigned char fats;		/*    16 */
	unsigned char dir_entries[2];	/* 17-18 */
	unsigned char sectors[2];	/* 19-20 */
	unsigned char media;		/*    21 */
	unsigned short fat_length;	/* 22-23 */
	unsigned short secs_track;	/* 24-25 */
	unsigned short heads;		/* 26-27 */
	unsigned long hidden;		/* 28-31 */
	/* ̌FAT16/32p̊gtB[h܂ */
} FAT_BOOT_SECTOR;
/*
ignored[3]	u[gvOւ̃Wv߁BʏA{0xeb,0x3c,0x90}łB
		Windows痘pꍇ́AȂƂ1oCgڂ0xebłȂƁAFATƂĔF܂B
		2`3oCgڂ͉ł\܂񂪁A{0xeb,0x3c,0x90}ƂĂ̂Ȃ悤łB
		Linux痘pꍇ́ÃtB[h͖悤łBimFj
system_id[8]	̃t@CVXe쐬OS̖OBʏA"MS-DOS5.0"łB
		Windows,Linuxǂ̃tB[h𖳎悤Ȃ̂ŁAS0ł\܂B
		A炩̎ʂɗpꍇɔāA"PIECE-ME"ƂĂƂɂ܂B
sector_size[2]	1ZN^̃oCgBʏAtbs[ł5121024AHDDł512łB
		Windows256,512,1024,2048,4096,8192܂ł̃ZN^TCYT|[gA
		Linux256,512,1024,2048,4096܂ł̃ZN^TCYT|[gĂ悤łBimFj
		AtbVɒFATt@CVXe\zꍇɔāA
		tbVƓZN^TCY4096ƂĂƂɂ܂B
cluster_size	1NX^̃ZN^BʏAtbs[ł12AHDDł͂Ƒ傫ȐɂȂ܂B
		1NX^1ZN^ƂĂ[FAT12̃NX^i4096|jɎ܂܂B
		܂A1NX^1ZN^Ȃ΃vOȒPɂȂ܂B
		1NX^1ZN^ƂAvO1NX^1ZN^OɎ邱Ƃɂ܂B
reserved	fBXN擪̗\ZN^BʏAtbs[ł1iu[gZN^̕jłB
		HDDł͂Ƒ̗\ZN^Ă悤łBimFj
		u[gZN^ȊOɗ\ZN^݂闝RɂȂ̂ŁA1Ƃ邱Ƃɂ܂B
		\ZN^̒ɁAFATZN^܂B
fats		FAT̐BʏAtbs[HDDł2łB
		FATj󂳂ꂽꍇɔāAFAT̃Rs[𕡐pӂĂ̂łA
		LinuxJ[lǂތAǂ̂悤ȕ@ŏCŝ͂悭킩܂łB
		FAT**j󂳂\͒ႢƍlA1iCiȂjƂ邱Ƃɂ܂B
		FATZN^̒ɁAfBNgZN^܂B
dir_entries[2]	fBNgGgBʏAtbs[ł100`200xłB
		fBNgZN^1ZN^ɗ}̂ŁA409632128Ƃ邱Ƃɂ܂B
		fBNgZN^̒ォAf[^̈iNX^#22x[X!jJn܂B
sectors[2]	fBXN̑SZN^BʏAtbs[ł2880xłBi512~28801.44MBj
		HDDɂ͂Ƒ̃ZN^A2oCgł͕\łȂ̂ŁA
		̃tB[h{0x00,0x00}ƂĂAgtB[hɃZN^i[܂B
		́Aőł2MB4096512ZN^ł̂ŁA2oCgŏ[\ł܂B
		t@CVXeɊĂeʂɂāAKXݒ肵ĂB
media		fBAR[hB2DD(9ZN^):0xf9A2DD(8ZN^):0xfbA2HD(8ZN^):0xfeAetc...B
		tbs[ȊÕfBAł́AʏA0xf8ƂȂĂ悤łB
		ɃfBAR[h0x00ɂĂ݂ƁAWindows͗płȂȂ܂B
		0xf8ǂӖĂ͖̂mFłA0xf8ƂĂ̂Ȃ悤łB
		Linux痘pꍇ́ÃtB[h͖悤łBimFj
fat_length	FAT̃ZN^BʏAtbs[ł2`3AHDDł͂Ƒ傫ȐłB
		Oq̏ł́A1ZN^FATGg 4096~8rbg12rbg2730 ƂȂA
		SẴNX^iZN^jɑ΂GgƂď[łB
		āAFAT̃ZN^1Ƃ邱Ƃɂ܂B
		Ȃ݂ɁAFAT̃ZN^͂̃tB[hŖĂ܂A
		fBNg̃ZN^sector_size[2]dir_entries[2]Zo܂B
		fBNg̃ZN^𖾎tB[h݂͑܂B
secs_track	1gbÑZN^BʏAtbs[ł8`9i8C`ȂƑ傫ȐjłB
		tbs[ȊOiHDDȂǁjł́A_~[̒lĂ܂B
		ƂA_~[l1ĂP[XmFł̂ŁA1Ƃ邱Ƃɂ܂B
		Linux́ÃtB[h0ƁAFATƂĔF܂B0̓_łB
heads		hCũwbhBʏAtbs[ł12Btbs[ȊOł̓_~[lłB
		secs_trackƓA_~[l1̃P[XmFł̂ŁA1Ƃ邱Ƃɂ܂B
		secs_trackƓALinux痘pꍇ́A0ȊO̒lłȂ΂܂B
hidden		sǃZN^֗p̗\BZN^H
		ǂ̂悤ɗpĂ̂悭킩܂łA0ŖȂ悤łB
hiddenȍ~ɂ́AFAT16/32ŗpgtB[h܂B
FAT12ł͎QƂ܂񂪁AFAT12/16FAT32̎ʃrbgȂǂ݂邽߁A0Ŗ߂ĂSłB
*/

typedef struct _MSDOS_DIR_ENTRY {
	unsigned char name[8];		/*  0- 7 */
	unsigned char ext[3];		/*  8-10 */
	unsigned char attr;		/*    11 */
	unsigned char reserved[10];	/* 12-21 */
	unsigned short time;		/* 22-23 */
	unsigned short date;		/* 24-25 */
	unsigned short start;		/* 26-27 */
	unsigned long size;		/* 28-31 */
} MSDOS_DIR_ENTRY;
/*
name[8]		t@CB8̏ꍇ́A󔒁i\x20jŃpfBO܂B
		ꕶڂ'\xe5'ȂÃGg͋󂫃GgłB
		ꕶڂ'\x00'ȂAȍ~̃Gg͓eɊւ炸Sċ󂫃GgłB
ext[3]		gqB3̏ꍇ́A󔒁i\x20jŃpfBO܂B
attr		bit0:ReadOnly/1:Hidden/2:System/3:VolumeLabel/4:Directory/5:Archived
reserved[10]	VFATł͗pĂ܂A͖邱Ƃɂ܂B
time		TODO:
date		TODO:
start		擪NX^̃NX^ԍłB
size		ۂ̃t@CTCYoCgPʂŊi[܂B
*/

/*
yAXL[oŋ pMS-DOS p.95 \2.3 FATGg̓ʂȒlƂ̈Ӗ z
FATGg̒l	Ӗ
0x000			ΉNX^͖gp
0x001			i̒l͎gȂj
0x002-0xff6		ΉNX^͎gpłA̒l͎̃NX^ԍĂ
0xff7			ΉNX^ɕsǃZN^
0xff8-0xfff		NX^ł邱Ƃiۂɂ0xfff݂̂gĂj
*/

#endif /*__USBSYS_H__*/
